section .text

    global _cpuida   

 _cpuida:

    push eax
    push ebx
    push ecx
    push edx
    push edi

    mov  eax, 1
    CPUID
    mov [eaxCode1], eax  ; Features Code
    mov [edxCode1], edx  ; family/model/stepping
    mov [ebxCode1], ebx
    mov [ecxCode1], ecx

    mov  edi, idString1
    mov  eax, 0
    CPUID
    mov[edi],   ebx
    mov[edi+4], edx
    mov[edi+8], ecx
    mov ecx, 0
    mov[edi+12], ecx
    mov [intel1amd2], ebx


    ; get specials
    mov eax,80000000h
    CPUID
    cmp eax,80000000h
    jc nomore

    mov eax, [intel1amd2]
    cmp eax, 756E6547h    ; uneG
    jz intel
    cmp eax, 68747541h    ; htuA
    jnz nomore
    mov eax,80000001h
    CPUID

    mov [ext81edx], edx

    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  edi, idString2
    mov eax,80000002h
    CPUID
    mov[edi],    eax
    mov[edi+4],  ebx
    mov[edi+8],  ecx
    mov[edi+12], edx
    mov eax,80000003h
    CPUID
    mov[edi+16], eax
    mov[edi+20], ebx
    mov[edi+24], ecx
    mov[edi+28], edx
    mov eax,80000004h
    CPUID
    mov[edi+32], eax
    mov[edi+36], ebx
    mov[edi+40], ecx
    mov[edi+44], edx
    mov ecx, 0
    mov[edi+48], ecx
    jmp nomore
   intel:
    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  edi, idString2
    mov eax,80000002h
    CPUID
    mov[edi],    eax
    mov[edi+4],  ebx
    mov[edi+8],  ecx
    mov[edi+12], edx
    mov eax,80000003h
    CPUID
    mov[edi+16], eax
    mov[edi+20], ebx
    mov[edi+24], ecx
    mov[edi+28], edx
    mov eax,80000004h
    CPUID
    mov[edi+32], eax
    mov[edi+36], ebx
    mov[edi+40], ecx
    mov[edi+44], edx
    mov ecx, 0
    mov[edi+48], ecx
   nomore:

    pop edi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret


section .data

 extern  idString1
 extern  idString2
 extern  eaxCode1
 extern  ebxCode1
 extern  ecxCode1
 extern  edxCode1
 extern  intel1amd2
 extern  ext81edx


section .text

    global _calculateMHz   

 _calculateMHz:

        push eax
        push edx
        push ebx 
        RDTSC 
        mov [startCount], eax 
        mov ebx, 25000
  outerloop:
        mov edx, 25000
  innerloop:    
        dec     edx
        jne     innerloop
        dec     ebx
        jne     outerloop
        RDTSC
        mov     [endCount], eax
        sub     eax, [startCount]
        mov     [cycleCount], eax        
        pop ebx
        pop edx
        pop eax
        ret

section .data

 extern  startCount
 extern  endCount
 extern  cycleCount

section .text

    global _SSEOne   

 _SSEOne:
       push    edx
       push    ebx
       push    edi
       mov     edx, [ks]
       mov     eax, [xs]
       mov     ecx, [ys]
       mov     ebx, [dsum]
       mov     edi,0                  
       movaps  xmm4, [ebx]
       align 8
  alp: movaps  xmm0, [eax+edi]
       movaps  xmm1, [eax+edi+16]
       movaps  xmm2, [eax+edi+32]
       movaps  xmm3, [eax+edi+48]
       mulps   xmm0, [ecx+edi]
       mulps   xmm1, [ecx+edi+16]
       mulps   xmm2, [ecx+edi+32]
       mulps   xmm3, [ecx+edi+48]
       add     edi,64               
       addps   xmm4, xmm0
       addps   xmm4, xmm1
       addps   xmm4, xmm2
       addps   xmm4, xmm3
       sub     edx,16                
       jg      alp                   
       movaps  [ebx], xmm4
       pop     edi
       pop     ebx
       pop     edx
       ret
       
section .text

    global _SSE2One   

 _SSE2One:      
       push    edx
       push    ebx
       push    edi
       mov     edx, [kd1]
       mov     eax, [xd]
       mov     ecx, [yd]
       mov     ebx, [dsum]
       mov     edi,0                  
       movapd  xmm4, [ebx]
       align 8
  xlp: movapd  xmm0, [eax+edi]
       movapd  xmm1, [eax+edi+16]
       movapd  xmm2, [eax+edi+32]
       movapd  xmm3, [eax+edi+48]
       mulpd   xmm0, [ecx+edi]
       mulpd   xmm1, [ecx+edi+16]
       mulpd   xmm2, [ecx+edi+32]
       mulpd   xmm3, [ecx+edi+48]
       add     edi,64               
       addpd   xmm4, xmm0
       addpd   xmm4, xmm1
       addpd   xmm4, xmm2
       addpd   xmm4, xmm3
       sub     edx,8                                    
       jg      xlp                   
       movapd  [ebx], xmm4
       pop     edi
       pop     ebx
       pop     edx
       ret
        
section .text

    global _SSETwo   

_SSETwo:
       push    edx
       push    ebx
       push    edi
       mov     edx, [ks]
       mov     eax, [xs]
       mov     ecx, [ys]
       mov     edi, 0
       align 8
  clp: movaps  xmm0, [eax+edi]
       movaps  xmm1, [eax+edi+16]
       movaps  xmm2, [eax+edi+32]
       movaps  xmm3, [eax+edi+48]
       addps   xmm0, [ecx+edi]
       addps   xmm1, [ecx+edi+16]
       addps   xmm2, [ecx+edi+32]
       addps   xmm3, [ecx+edi+48]
       movaps  [eax+edi], xmm0
       movaps  [eax+edi+16], xmm1
       movaps  [eax+edi+32], xmm2
       movaps  [eax+edi+48], xmm3
       add     edi,64       
       sub     edx,16        
       jg      clp
       pop     edi
       pop     ebx
       pop     edx
       ret
       
section .text

    global _SSE2Two   

_SSE2Two:
       push    edx
       push    ebx
       push    edi
       mov     edx, [kd1]
       mov     eax, [xd]
       mov     ecx, [yd]
       mov     edi, 0
       align 8
  dlp: movapd  xmm0, [eax+edi]
       movapd  xmm1, [eax+edi+16]
       movapd  xmm2, [eax+edi+32]
       movapd  xmm3, [eax+edi+48]
       addpd   xmm0, [ecx+edi]
       addpd   xmm1, [ecx+edi+16]
       addpd   xmm2, [ecx+edi+32]
       addpd   xmm3, [ecx+edi+48]
       movapd  [eax+edi], xmm0
       movapd  [eax+edi+16], xmm1
       movapd  [eax+edi+32], xmm2
       movapd  [eax+edi+48], xmm3
       add     edi,64       
       sub     edx,8        
       jg      dlp                        
       pop     edi
       pop     ebx
       pop     edx
       ret

section .text

    global _SSEOnem   

 _SSEOnem:
       push    edx
       push    ebx
       push    edi
       mov     edx, [ks2]
       mov     eax, [xs]
       mov     ecx, [ys]
       mov     ebx, [dsum]
       mov     edi,0                  
       movaps  xmm0, [ebx]
       movaps  xmm1, [ebx+16]
       movaps  xmm2, [ebx+32]
       movaps  xmm3, [ebx+48]
       movaps  xmm4, [ebx+64]
       movaps  xmm5, [ebx+80]
       movaps  xmm6, [ebx+96]
       movaps  xmm7, [ebx+112]
     align 16
  flp: addps   xmm0, [ecx+edi]
       addps   xmm1, [ecx+edi+16]
       addps   xmm2, [ecx+edi+32]
       addps   xmm3, [ecx+edi+48]
       addps   xmm4, [ecx+edi+64]
       addps   xmm5, [ecx+edi+80]
       addps   xmm6, [ecx+edi+96]
       addps   xmm7, [ecx+edi+112]
       mulps   xmm0, [eax+edi]
       mulps   xmm1, [eax+edi+16]
       mulps   xmm2, [eax+edi+32]
       mulps   xmm3, [eax+edi+48]
       mulps   xmm4, [eax+edi+64]
       mulps   xmm5, [eax+edi+80]
       mulps   xmm6, [eax+edi+96]
       mulps   xmm7, [eax+edi+112]
       add     edi,128               
       sub     edx,16                
       jg      flp  
       movaps  [ebx], xmm0
       movaps  [ebx+16], xmm1
       movaps  [ebx+32], xmm2
       movaps  [ebx+48], xmm3 
       movaps  [ebx+64], xmm4 
       movaps  [ebx+80], xmm5 
       movaps  [ebx+96], xmm6 
       movaps  [ebx+112], xmm7 
       pop     edi
       pop     ebx
       pop     edx
       ret

section .text

    global _SSEOnen   

 _SSEOnen:
       push    edx
       push    ebx
       push    edi
       mov     edx, [ks2]
       mov     eax, [xs]
       mov     ecx, [ys]
       mov     ebx, [dsum]
       mov     edi,0                  
       movaps  xmm0, [ebx]
       movaps  xmm1, [ebx+16]
       movaps  xmm2, [ebx+32]
       movaps  xmm3, [ebx+48]
       movaps  xmm4, [ebx+64]
       movaps  xmm5, [ebx+80]
       movaps  xmm6, [ebx+96]
       movaps  xmm7, [ebx+112]
     align 16
  glp: addps   xmm0, [ecx+edi]
       addps   xmm1, [ecx+edi+16]
       addps   xmm2, [ecx+edi+32]
       addps   xmm3, [ecx+edi+48]
       addps   xmm4, [ecx+edi+64]
       addps   xmm5, [ecx+edi+80]
       addps   xmm6, [ecx+edi+96]
       addps   xmm7, [ecx+edi+112]
       addps   xmm0, [eax+edi]
       addps   xmm1, [eax+edi+16]
       addps   xmm2, [eax+edi+32]
       addps   xmm3, [eax+edi+48]
       addps   xmm4, [eax+edi+64]
       addps   xmm5, [eax+edi+80]
       addps   xmm6, [eax+edi+96]
       addps   xmm7, [eax+edi+112]
       add     edi,128               
       sub     edx,16                
       jg      glp  
       movaps  [ebx], xmm0
       movaps  [ebx+16], xmm1
       movaps  [ebx+32], xmm2
       movaps  [ebx+48], xmm3 
       movaps  [ebx+64], xmm4 
       movaps  [ebx+80], xmm5 
       movaps  [ebx+96], xmm6 
       movaps  [ebx+112], xmm7 
       pop     edi
       pop     ebx
       pop     edx
       ret

section .data

 extern  ks
 extern  ks2
 extern  kd1
 extern  xd
 extern  yd
 extern  xs
 extern  ys
 extern  dsum
 
 
 

