;  nasm -f elf64 -g -F stabs sse64.asm   ;for sse64.o

section .text

    global _cpuida   

 _cpuida:

    push rax
    push rbx
    push rcx
    push rdx
    push rdi

    mov  eax, 1
    CPUID
    mov [eaxCode1], eax  ; Features Code
    mov [edxCode1], edx  ; family/model/stepping
    mov [ebxCode1], ebx
    mov [ecxCode1], ecx

    mov  rdi, idString1
    mov  eax, 0
    CPUID
    mov[rdi],   ebx
    mov[rdi+4], edx
    mov[rdi+8], ecx
    mov ecx, 0
    mov[rdi+12], ecx
    mov [intel1amd2], ebx


    ; get specials
    mov eax,80000000h
    CPUID
    cmp eax,80000000h
    jc nomore

    mov eax, [intel1amd2]
    cmp eax, 756E6547h    ; uneG
    jz intel
    cmp eax, 68747541h    ; htuA
    jnz nomore
    mov eax,80000001h
    CPUID

    mov [ext81edx], edx

    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  rdi, idString2
    mov eax,80000002h
    CPUID
    mov[rdi],    eax
    mov[rdi+4],  ebx
    mov[rdi+8],  ecx
    mov[rdi+12], edx
    mov eax,80000003h
    CPUID
    mov[rdi+16], eax
    mov[rdi+20], ebx
    mov[rdi+24], ecx
    mov[rdi+28], edx
    mov eax,80000004h
    CPUID
    mov[rdi+32], eax
    mov[rdi+36], ebx
    mov[rdi+40], ecx
    mov[rdi+44], edx
    mov ecx, 0
    mov[rdi+48], ecx
    jmp nomore
   intel:
    mov eax,80000000h
    CPUID
    cmp eax,80000004h
    jc nomore                
    mov  rdi, idString2
    mov eax,80000002h
    CPUID
    mov[rdi],    eax
    mov[rdi+4],  ebx
    mov[rdi+8],  ecx
    mov[rdi+12], edx
    mov eax,80000003h
    CPUID
    mov[rdi+16], eax
    mov[rdi+20], ebx
    mov[rdi+24], ecx
    mov[rdi+28], edx
    mov eax,80000004h
    CPUID
    mov[rdi+32], eax
    mov[rdi+36], ebx
    mov[rdi+40], ecx
    mov[rdi+44], edx
    mov ecx, 0
    mov[rdi+48], ecx
   nomore:

    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret

section .data

 extern  idString1
 extern  idString2
 extern  eaxCode1
 extern  ebxCode1
 extern  ecxCode1
 extern  edxCode1
 extern  intel1amd2
 extern  ext81edx


section .text

    global _calculateMHz   

 _calculateMHz:

        push rax
        push rdx
        push rbx 
        RDTSC 
        mov [startCount], eax 
        mov ebx, 25000
  outerloop:
        mov edx, 25000
  innerloop:    
        dec     edx
        jne     innerloop
        dec     ebx
        jne     outerloop
        RDTSC
        mov     [endCount], eax
        sub     eax, [startCount]
        mov     [cycleCount], eax        
        pop rbx
        pop rdx
        pop rax
        ret

section .data

 extern  startCount
 extern  endCount
 extern  cycleCount

section .text

    global _SSEOne   

 _SSEOne:
       push    rdx
       push    rbx
       push    rdi
       mov     rdx, [ks]
       mov     rax, [xs]
       mov     rcx, [ys]
       mov     rbx, [dsum]
       mov     rdi,0                  
       movaps  xmm4, [rbx]
       align 8
  alp: movaps  xmm0, [rax+rdi]
       movaps  xmm1, [rax+rdi+16]
       movaps  xmm2, [rax+rdi+32]
       movaps  xmm3, [rax+rdi+48]
       mulps   xmm0, [rcx+rdi]
       mulps   xmm1, [rcx+rdi+16]
       mulps   xmm2, [rcx+rdi+32]
       mulps   xmm3, [rcx+rdi+48]
       add     rdi,64               
       addps   xmm4, xmm0
       addps   xmm4, xmm1
       addps   xmm4, xmm2
       addps   xmm4, xmm3
       sub     rdx,16                
       jg      alp                   
       movaps  [rbx], xmm4
       pop     rdi
       pop     rbx
       pop     rdx
       ret
       
section .text

    global _SSE2One   

 _SSE2One:      
       push    rdx
       push    rbx
       push    rdi
       mov     rdx, [kd1]
       mov     rax, [xd]
       mov     rcx, [yd]
       mov     rbx, [dsum]
       mov     rdi,0                  
       movapd  xmm4, [rbx]
       align 8
  xlp: movapd  xmm0, [rax+rdi]
       movapd  xmm1, [rax+rdi+16]
       movapd  xmm2, [rax+rdi+32]
       movapd  xmm3, [rax+rdi+48]
       mulpd   xmm0, [rcx+rdi]
       mulpd   xmm1, [rcx+rdi+16]
       mulpd   xmm2, [rcx+rdi+32]
       mulpd   xmm3, [rcx+rdi+48]
       add     rdi,64               
       addpd   xmm4, xmm0
       addpd   xmm4, xmm1
       addpd   xmm4, xmm2
       addpd   xmm4, xmm3
       sub     rdx,8                                    
       jg      xlp                   
       movapd  [rbx], xmm4
       pop     rdi
       pop     rbx
       pop     rdx
       ret
        
section .text

    global _SSETwo   

_SSETwo:
       push    rdx
       push    rbx
       push    rdi
       mov     rdx, [ks]
       mov     rax, [xs]
       mov     rcx, [ys]
       mov     rdi, 0
       align 8
  clp: movaps  xmm0, [rax+rdi]
       movaps  xmm1, [rax+rdi+16]
       movaps  xmm2, [rax+rdi+32]
       movaps  xmm3, [rax+rdi+48]
       addps   xmm0, [rcx+rdi]
       addps   xmm1, [rcx+rdi+16]
       addps   xmm2, [rcx+rdi+32]
       addps   xmm3, [rcx+rdi+48]
       movaps  [rax+rdi], xmm0
       movaps  [rax+rdi+16], xmm1
       movaps  [rax+rdi+32], xmm2
       movaps  [rax+rdi+48], xmm3
       add     rdi,64       
       sub     rdx,16        
       jg      clp
       pop     rdi
       pop     rbx
       pop     rdx
       ret
       
section .text

    global _SSE2Two   

_SSE2Two:
       push    rdx
       push    rbx
       push    rdi
       mov     rdx, [kd1]
       mov     rax, [xd]
       mov     rcx, [yd]
       mov     rdi, 0
       align 8
  dlp: movapd  xmm0, [rax+rdi]
       movapd  xmm1, [rax+rdi+16]
       movapd  xmm2, [rax+rdi+32]
       movapd  xmm3, [rax+rdi+48]
       addpd   xmm0, [rcx+rdi]
       addpd   xmm1, [rcx+rdi+16]
       addpd   xmm2, [rcx+rdi+32]
       addpd   xmm3, [rcx+rdi+48]
       movapd  [rax+rdi], xmm0
       movapd  [rax+rdi+16], xmm1
       movapd  [rax+rdi+32], xmm2
       movapd  [rax+rdi+48], xmm3
       add     rdi,64       
       sub     rdx,8        
       jg      dlp                        
       pop     rdi
       pop     rbx
       pop     rdx
       ret

section .text

    global _SSEOnem   

 _SSEOnem:
       push    rdx
       push    rbx
       push    rdi
       mov     rdx, [ks2]
       mov     rax, [xs]
       mov     rcx, [ys]
       mov     rbx, [dsum]
       mov     rdi,0                  
       movaps  xmm0, [rbx]
       movaps  xmm1, [rbx+16]
       movaps  xmm2, [rbx+32]
       movaps  xmm3, [rbx+48]
       movaps  xmm4, [rbx+64]
       movaps  xmm5, [rbx+80]
       movaps  xmm6, [rbx+96]
       movaps  xmm7, [rbx+112]
     align 16
  flp: addps   xmm0, [rcx+rdi]
       addps   xmm1, [rcx+rdi+16]
       addps   xmm2, [rcx+rdi+32]
       addps   xmm3, [rcx+rdi+48]
       addps   xmm4, [rcx+rdi+64]
       addps   xmm5, [rcx+rdi+80]
       addps   xmm6, [rcx+rdi+96]
       addps   xmm7, [rcx+rdi+112]
       mulps   xmm0, [rax+rdi]
       mulps   xmm1, [rax+rdi+16]
       mulps   xmm2, [rax+rdi+32]
       mulps   xmm3, [rax+rdi+48]
       mulps   xmm4, [rax+rdi+64]
       mulps   xmm5, [rax+rdi+80]
       mulps   xmm6, [rax+rdi+96]
       mulps   xmm7, [rax+rdi+112]
       add     rdi,128               
       sub     rdx,16                
       jg      flp  
       movaps  [rbx], xmm0
       movaps  [rbx+16], xmm1
       movaps  [rbx+32], xmm2
       movaps  [rbx+48], xmm3 
       movaps  [rbx+64], xmm4 
       movaps  [rbx+80], xmm5 
       movaps  [rbx+96], xmm6 
       movaps  [rbx+112], xmm7 
       pop     rdi
       pop     rbx
       pop     rdx
       ret

section .text

    global _SSEOnen   

 _SSEOnen:
       push    rdx
       push    rbx
       push    rdi
       mov     rdx, [ks2]
       mov     rax, [xs]
       mov     rcx, [ys]
       mov     rbx, [dsum]
       mov     rdi,0                  
       movaps  xmm0, [rbx]
       movaps  xmm1, [rbx+16]
       movaps  xmm2, [rbx+32]
       movaps  xmm3, [rbx+48]
       movaps  xmm4, [rbx+64]
       movaps  xmm5, [rbx+80]
       movaps  xmm6, [rbx+96]
       movaps  xmm7, [rbx+112]
       align 16
  glp: addps   xmm0, [rcx+rdi]
       addps   xmm1, [rcx+rdi+16]
       addps   xmm2, [rcx+rdi+32]
       addps   xmm3, [rcx+rdi+48]
       addps   xmm4, [rcx+rdi+64]
       addps   xmm5, [rcx+rdi+80]
       addps   xmm6, [rcx+rdi+96]
       addps   xmm7, [rcx+rdi+112]
       addps   xmm0, [rax+rdi]
       addps   xmm1, [rax+rdi+16]
       addps   xmm2, [rax+rdi+32]
       addps   xmm3, [rax+rdi+48]
       addps   xmm4, [rax+rdi+64]
       addps   xmm5, [rax+rdi+80]
       addps   xmm6, [rax+rdi+96]
       addps   xmm7, [rax+rdi+112]
       add     rdi,128               
       sub     rdx,16                
       jg      glp  
       movaps  [rbx], xmm0
       movaps  [rbx+16], xmm1
       movaps  [rbx+32], xmm2
       movaps  [rbx+48], xmm3 
       movaps  [rbx+64], xmm4 
       movaps  [rbx+80], xmm5 
       movaps  [rbx+96], xmm6 
       movaps  [rbx+112], xmm7 
       pop     rdi
       pop     rbx
       pop     rdx
       ret

section .data

 extern  ks
 extern  ks2
 extern  kd1
 extern  xd
 extern  yd
 extern  xs
 extern  ys
 extern  dsum
 
 
 

